uses
  sdl;

function GetKey(sym:TSDL_KeySym):word;
begin
  if sym.sym<>0 then
    result:=sym.sym
  else
    result:=sym.scancode;

  if sym.unicode<>0 then
    result:=sym.unicode;
end;

function xdwrap_event_getevent_sdl(var event:TXDEvent):Integer;
var
  events:TSDL_Event;
begin
  if SDL_PollEvent(@events)=1 then
  begin
    result:=1;
    event.type_:=0;
    event.key:=0;
    event.motion.x:=0;
    event.motion.y:=0;
    event.motion.xrel:=0;
    event.motion.yrel:=0;
    event.button.button:=0;
    event.button.x:=0;
    event.button.y:=0;
    event.resize.width:=0;
    event.resize.height:=0;
    case events.type_ of
      SDL_QUITEV:event.type_:=OnQuit;
      SDL_ActiveEvent:event.type_:=OnActive;
      SDL_KeyDown:begin
                    event.type_:=OnKeyDown;
                    event.key:=getkey(events.key.keysym);
                  end;
      SDL_KeyUp:begin
                  event.type_:=OnKeyUp;
                  event.key:=getkey(events.key.keysym);
                end;
      SDL_MouseMotion:begin
                        event.type_:=OnMouseMove;
                        event.motion.x:=events.motion.x;
                        event.motion.y:=events.motion.y;
                        event.motion.xrel:=events.motion.xrel;
                        event.motion.yrel:=events.motion.yrel;
                      end;
      SDL_MouseButtonDown:begin
                            event.type_:=OnMouseDown;
                            event.button.button:=events.button.button;
                            event.button.x:=events.button.x;
                            event.button.y:=events.button.y;
                          end;
      SDL_MouseButtonUp:begin
                          event.type_:=OnMouseUp;
                          event.button.button:=events.button.button;
                          event.button.x:=events.button.x;
                          event.button.y:=events.button.y;
                        end;
      SDL_VideoResize:begin
                        event.type_:=OnResize;
                        event.resize.width:=events.resize.w;
                        event.resize.height:=events.resize.h;
                      end;
      SDL_VideoExpose:event.type_:=OnExpose;
    end;
  end else result:=0;
end;

procedure xdwrap_UseUnicode_sdl(val:Boolean);
begin
  if val then
    SDL_EnableUNICODE(1)
  else
    SDL_EnableUNICODE(0)
end;

procedure xdwrap_UseKeyboardRepeat_sdl(val:Boolean);
begin
  if val then
    SDL_EnableKeyRepeat(SDL_DEFAULT_REPEAT_DELAY, SDL_DEFAULT_REPEAT_INTERVAL)
  else
    SDL_EnableKeyRepeat(0,0);
end;

procedure init_event;
begin
  xdwrap_event_getevent    :=xdwrap_event_getevent_sdl;
  xdwrap_UseUnicode        :=xdwrap_UseUnicode_sdl;
  xdwrap_UseKeyboardRepeat :=xdwrap_UseKeyboardRepeat_sdl;
end;