unit xdwrap_window;

interface

uses
  sysutils;

const
  WND_TYPE_DIALOG    =0;
  WND_TYPE_FULLSCREEN=1;
  WND_TYPE_NOFRAME   =2;
  WND_TYPE_RESIZEABLE=3;

type
  xdwrap_Window_Error=class(Exception);
  
  //ndert den Titel des Fensters
  pxdwrap_window_setcaption   =procedure (title:string);
  //ndert das Icon des Fensters
  pxdwrap_window_seticon      =procedure (filename:string);
  //liest den Titel des Fensters aus
  pxdwrap_window_getcaption   =function ():string;
  //liest den Iconnamen, des Fensters, aus
  pxdwrap_window_geticon      =function ():string;
  //initialisiert das Fenster
  pxdwrap_window_init         =function ():integer;
  //erstellt ein Fenster
  pxdwrap_window_create       =function (width,height:integer;depth,flags:cardinal):Boolean;
  //bringt das Fenster in den Vollbildmodus
  pxdwrap_window_togglefullscreen=function ():Boolean;
  //minimiert das Fenster
  pxdwrap_window_minimize     =function ():Boolean;
  //fixiert die Maus auf den Fensterbereich
  pxdwrap_window_fixmouse     =procedure (fixmode:Boolean);
  //swap Backbuffer with Frontbuffer
  pxdwrap_window_swapbuffer   =procedure;

var
  xdwrap_window_setcaption:pxdwrap_window_setcaption;
  xdwrap_window_seticon:pxdwrap_window_seticon;
  xdwrap_window_getcaption:pxdwrap_window_getcaption;
  xdwrap_window_geticon:pxdwrap_window_geticon;
  xdwrap_window_init:pxdwrap_window_init;
  xdwrap_window_create:pxdwrap_window_create;
  xdwrap_window_togglefullscreen:pxdwrap_window_togglefullscreen;
  xdwrap_window_minimize:pxdwrap_window_minimize;
  xdwrap_window_fixmouse:pxdwrap_window_fixmouse;
  xdwrap_window_swapbuffer:pxdwrap_window_swapbuffer;

implementation

{$I xdwrap_windowcode.inc}

initialization
  init_window;

end.